#include <stm32f10x_lib.h>

void stm32_Init(void);
void testBuzzer(void);
void testDisplay(void);
void testTriac(void);
void lightSensorTest(void);

void SystemInit()
{
	// enable all GPIO and Alternate Function clocks
	RCC->APB2ENR  |=0x021D;

	// enable the pull up on PC0-3
	// and the output for Sensor Power on PC4
	GPIOC->ODR = 0x0000001F;
}

typedef enum test_number
{
	DISPLAY = 0,
	BUZZER,
	SUN,
	LIGHTSENSOR,
	NONE
} testNumber;

testNumber test = NONE;

int main (void)
{
	stm32_Init();

initRTC();
//initTempSensor();
//getTemperature();
	
	while(1)
	{
		switch( test )
		{
			case BUZZER:	   
				testBuzzer();  
				break;
			case DISPLAY:
				testDisplay();
				break;
			case SUN:
				testTriac();
				break;
			case LIGHTSENSOR:
				lightSensorTest();
				break;
			default: break;
		}
	}
	
} 

void EXTI0_IRQHandler()
{
	// clear the interrupt
	EXTI->PR &= 0x000000001;

	// set the test number
	test = BUZZER;
}

void EXTI1_IRQHandler()
{
	// clear the interrupt
	EXTI->PR &= 0x000000002;

	// set the test number
	test = DISPLAY;
}

void EXTI2_IRQHandler()
{
	// clear the interrupt
	EXTI->PR &= 0x000000004;

	// set the test number
	test = SUN;

}

void EXTI3_IRQHandler()
{
	// clear the interrupt
	EXTI->PR &= 0x000000008;

	// set the test number
	test = LIGHTSENSOR;
}

void assert_failed()
{

}
