#include "stm32f10x_lib.h"
#include "RTC.h"
#include "STM32_Reg.h"
#include "STM32_Init.h"

extern struct Time rtd;

void GetRtc()
{

unsigned int countread1;
unsigned int countread2;

unsigned long count;
 countread1 =  RTC->CNTL;
 countread2 =  RTC->CNTH;


count =  countread2 *(0x10000) + countread1 ;
count = count % 86400 ;
rtd.hr = (count / 3600);
rtd.min = (count % 3600) / 60;
rtd.sec = ((count % 3600) % 60);

}

void GerAlarm()
{
unsigned int countread1;
unsigned int countread2;

unsigned long count;
 countread1 =  RTC->ALRH;
 countread2 =  RTC->ALRH;


count =  countread2 *(0x10000) + countread1 ;
count = count % 86400 ;
rtd.alarmhr = (count / 3600);
rtd.alarmmin = (count % 3600) / 60;

}

void Savertc()

{
unsigned long count;
unsigned long alarmcount;
count =  ((rtd.hr *3600UL)+(rtd.min *60UL)+(rtd.sec) )	 ;
alarmcount = ((rtd.alarmhr *3600UL)+(rtd.alarmmin *60UL) )	 ;
   RCC->APB1ENR |= RCC_APB1ENR_PWREN;                            // enable clock for Power interface
   RCC->APB1ENR |= RCC_APB1ENR_BKPEN;							 // enable clock for backup interface
  PWR->CR      |= PWR_CR_DBP;                                   // enable access to RTC, BDC registers
  if ((__RTC_CLKSRC_VAL & RCC_BDCR_RTCSEL) == 0x00000100) {     // LSE is RTC clock source
    RCC->BDCR |= RCC_BDCR_LSEON;                                // enable LSE
    while ((RCC->BDCR & RCC_BDCR_LSERDY) == 0);                 // Wait for LSERDY = 1 (LSE is ready)
  }
  if ((__RTC_CLKSRC_VAL & RCC_BDCR_RTCSEL) == 0x00000200) {     // LSI is RTC clock source
    RCC->CSR |= RCC_CSR_LSION;                                  // enable LSI
    while ((RCC->CSR & RCC_CSR_LSIRDY) == 0);                   // Wait for LSERDY = 1 (LSE is ready)
  }
  RCC->BDCR |= (__RTC_CLKSRC_VAL | RCC_BDCR_RTCEN);             // set RTC clock source, enable RTC clock
  RTC->CRL  |=  RTC_CRL_CNF;                                    // set configuration mode
  RTC->PRLH  = ((__RTC_PERIOD*__RTCCLK/1000-1)>>16) & 0x00FF;   // set prescaler load register high
  RTC->PRLL  = ((__RTC_PERIOD*__RTCCLK/1000-1)    ) & 0xFFFF;   // set prescaler load register low

  RTC->CNTH  = ((count)>>16) & 0xFFFF;                      // set counter high
  
  RTC->CNTL  = ((count)    ) & 0xFFFF;                      // set counter low

    RTC->ALRH  = ((alarmcount)>>16) & 0xFFFF;                      // set alarm high
    RTC->ALRL  = ((alarmcount)    ) & 0xFFFF;                      // set alarm low


  if (__RTC_INTERRUPTS) {                                       // RTC interrupts used
    RTC->CRH = __RTC_CRH;                                       // enable RTC interrupts
    NVIC->ISER[0] |= (1 << (RTC_IRQChannel & 0x1F));            // enable interrupt
  }
  RTC->CRL  &= ~RTC_CRL_CNF;                                    // reset configuration mode
  while ((RTC->CRL & RTC_CRL_RTOFF) == 0);                      // wait until write is finished

  PWR->CR   &= ~PWR_CR_DBP;                                     // disable access to RTC registers
}






void SaveAlarm()
{

unsigned long count;
PWR->CR      |= PWR_CR_DBP;  
count = (  rtd.alarmmin * 60UL + rtd.alarmhr * 3600UL) ;
count = count * 1000UL / __RTC_PERIOD;
   RTC->ALRH = ((count)>>16) & 0xFFFF;                      // set alarm counter high
   RTC->ALRL  = ((count)    ) & 0xFFFF;  					 // set alarm counter LOW
 PWR->CR   &= ~PWR_CR_DBP;  

}


