#include "stm32f10x_lib.h"
#include "STM32_Reg.h"
#include "STM32_Init.h"

/*------------------------------------------------------------------------------
  This is the zero detect input interrupt config function 
 *------------------------------------------------------------------------------*/

void EXITinit()

{
 /*   RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;                     // enable clock for Alternate Function
    AFIO->EXTICR[0] &= 0xF0FF;                              // clear used pin
    AFIO->EXTICR[0] |= (0x0F00 & __AFIO_EXTICR1);           // set pin to use

    EXTI->IMR       |= ((1 << 2) & __EXTI_IMR);             // unmask interrupt
    EXTI->EMR       |= ((1 << 2) & __EXTI_EMR);             // unmask event
    EXTI->RTSR      |= ((1 << 2) & __EXTI_RTSR);            // set rising edge
    EXTI->FTSR      |= ((1 << 2) & __EXTI_FTSR);            // set falling edge
                   // interrupt used
      NVIC->ISER[0] |= (1 << (EXTI2_IRQChannel & 0x1F));    // enable interrupt EXTI 2
*/
 if (__EXTI_USED & (1 << 0)) {                             // EXTI0 used

    RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;                     // enable clock for Alternate Function
    AFIO->EXTICR[0] &= 0xFFF0;                              // clear used pin
    AFIO->EXTICR[0] |= (0x000F & __AFIO_EXTICR1);           // set pin to use

    EXTI->IMR       |= ((1 << 0) & __EXTI_IMR);             // unmask interrupt
    EXTI->EMR       |= ((1 << 0) & __EXTI_EMR);             // unmask event
    EXTI->RTSR      |= ((1 << 0) & __EXTI_RTSR);            // set rising edge
    EXTI->FTSR      |= ((1 << 0) & __EXTI_FTSR);            // set falling edge

    if (__EXTI_INTERRUPTS & (1 << 0)) {                     // interrupt used
      NVIC->ISER[0] |= (1 << (EXTI0_IRQChannel & 0x1F));    // enable interrupt EXTI 0
    }
  } // end EXTI0 used

  if (__EXTI_USED & (1 << 1)) {                             // EXTI1 used

    RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;                     // enable clock for Alternate Function
    AFIO->EXTICR[0] &= 0xFF0F;                              // clear used pin
    AFIO->EXTICR[0] |= (0x00F0 & __AFIO_EXTICR1);           // set pin to use

    EXTI->IMR       |= ((1 << 1) & __EXTI_IMR);             // unmask interrupt
    EXTI->EMR       |= ((1 << 1) & __EXTI_EMR);             // unmask event
    EXTI->RTSR      |= ((1 << 1) & __EXTI_RTSR);            // set rising edge
    EXTI->FTSR      |= ((1 << 1) & __EXTI_FTSR);            // set falling edge

    if (__EXTI_INTERRUPTS & (1 << 1)) {                     // interrupt used
      NVIC->ISER[0] |= (1 << (EXTI1_IRQChannel & 0x1F));    // enable interrupt EXTI 1
    }
  } // end EXTI1 used

  if (__EXTI_USED & (1 << 2)) {                             // EXTI2 used

    RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;                     // enable clock for Alternate Function
    AFIO->EXTICR[0] &= 0xF0FF;                              // clear used pin
    AFIO->EXTICR[0] |= (0x0F00 & __AFIO_EXTICR1);           // set pin to use

    EXTI->IMR       |= ((1 << 2) & __EXTI_IMR);             // unmask interrupt
    EXTI->EMR       |= ((1 << 2) & __EXTI_EMR);             // unmask event
    EXTI->RTSR      |= ((1 << 2) & __EXTI_RTSR);            // set rising edge
    EXTI->FTSR      |= ((1 << 2) & __EXTI_FTSR);            // set falling edge

    if (__EXTI_INTERRUPTS & (1 << 2)) {                     // interrupt used
      NVIC->ISER[0] |= (1 << (EXTI2_IRQChannel & 0x1F));    // enable interrupt EXTI 2
    }
  } // end EXTI2 used

  if (__EXTI_USED & (1 << 3)) {                             // EXTI3 used

    RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;                     // enable clock for Alternate Function
    AFIO->EXTICR[0] &= 0x0FFF;                              // clear used pin
    AFIO->EXTICR[0] |= (0xF000 & __AFIO_EXTICR1);           // set pin to use

    EXTI->IMR       |= ((1 << 3) & __EXTI_IMR);             // unmask interrupt
    EXTI->EMR       |= ((1 << 3) & __EXTI_EMR);             // unmask event
    EXTI->RTSR      |= ((1 << 3) & __EXTI_RTSR);            // set rising edge
    EXTI->FTSR      |= ((1 << 3) & __EXTI_FTSR);            // set falling edge

    if (__EXTI_INTERRUPTS & (1 << 3)) {                     // interrupt used
      NVIC->ISER[0] |= (1 << (EXTI3_IRQChannel & 0x1F));    // enable interrupt EXTI 3
    }
  } // end EXTI3 used

								
}

/*------------------------------------------------------------------------------
  This is the RTC config function 
 *------------------------------------------------------------------------------*/
void RTC_Init()
{

   RCC->APB1ENR |= RCC_APB1ENR_PWREN;                            // enable clock for Power interface
   RCC->APB1ENR |= RCC_APB1ENR_BKPEN;							 // enable clock for backup interface
  PWR->CR      |= PWR_CR_DBP;                                   // enable access to RTC, BDC registers
  if ((__RTC_CLKSRC_VAL & RCC_BDCR_RTCSEL) == 0x00000100) {     // LSE is RTC clock source
    RCC->BDCR |= RCC_BDCR_LSEON;                                // enable LSE
    while ((RCC->BDCR & RCC_BDCR_LSERDY) == 0);                 // Wait for LSERDY = 1 (LSE is ready)
  }
  if ((__RTC_CLKSRC_VAL & RCC_BDCR_RTCSEL) == 0x00000200) {     // LSI is RTC clock source
    RCC->CSR |= RCC_CSR_LSION;                                  // enable LSI
    while ((RCC->CSR & RCC_CSR_LSIRDY) == 0);                   // Wait for LSERDY = 1 (LSE is ready)
  }
  RCC->BDCR |= (__RTC_CLKSRC_VAL | RCC_BDCR_RTCEN);             // set RTC clock source, enable RTC clock
  RTC->CRL  |=  RTC_CRL_CNF;                                    // set configuration mode
  RTC->PRLH  = ((__RTC_PERIOD*__RTCCLK/1000-1)>>16) & 0x00FF;   // set prescaler load register high
  RTC->PRLL  = ((__RTC_PERIOD*__RTCCLK/1000-1)    ) & 0xFFFF;   // set prescaler load register low

//  RTC->CNTH  = ((__RTC_CNT)>>16) & 0xFFFF;                      // set counter high
  
 // RTC->CNTL  = ((__RTC_CNT)    ) & 0xFFFF;                      // set counter low
//  RTC->ALRH  = ((__RTC_ALR)>>16) & 0xFFFF;                      // set alarm high
 // RTC->ALRL  = ((__RTC_ALR)    ) & 0xFFFF;                      // set alarm low
  if (__RTC_INTERRUPTS) {                                       // RTC interrupts used
    RTC->CRH = __RTC_CRH;                                       // enable RTC interrupts
    NVIC->ISER[0] |= (1 << (RTC_IRQChannel & 0x1F));            // enable interrupt
  }
  RTC->CRL  &= ~RTC_CRL_CNF;                                    // reset configuration mode
  while ((RTC->CRL & RTC_CRL_RTOFF) == 0);                      // wait until write is finished

  PWR->CR   &= ~PWR_CR_DBP;                                     // disable access to RTC registers

}

/*------------------------------------------------------------------------------
  This is the Timer2 config function 
 *------------------------------------------------------------------------------*/

void Timer2()
{
	RCC->APB1ENR |= RCC_APB1ENR_TIM2EN;                     // enable clock for TIM2
	TIM2->RCR = 0 ;										//00000000
	TIM2->CR1 = 0;                                          // reset command register 1
	TIM2->CR2 = 0;                                          // reset command register 2
	TIM2->PSC = __TIM2_PSC;                               // set prescaler
	TIM2->ARR = __TIM2_ARR;                               // set auto-reload
	TIM2->CCR1  = __TIM2_CCR1;                            //
	TIM2->CCR2  = __TIM2_CCR2;                            //
	TIM2->CCR3  = __TIM2_CCR3;                            //
	TIM2->CCR4  = __TIM2_CCR4;                            //
	TIM2->CCMR1 = __TIM2_CCMR1;                           //
	TIM2->CCMR2 = __TIM2_CCMR2;                           //
	TIM2->CCER  = __TIM2_CCER;                            // set capture/compare enable register
	TIM2->SMCR  = __TIM2_SMCR;                            // set slave mode control register
	TIM2->CR1 = __TIM2_CR1;                               // set command register 1
	TIM2->CR2 = __TIM2_CR2;                               // set command register 2
	TIM2->DIER = __TIM2_EIER;                             // enable interrupt
	NVIC->ISER[0] |= (1 << (TIM2_IRQChannel & 0x1F));  // enable interrupt
    TIM2->CR1 |= TIMX_CR1_CEN;                              // enable timer

}
void Timer3()
{
	RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;                     // enable clock for TIM2
	TIM3->RCR = 0 ;										//00000000
	TIM3->CR1 = 0;                                          // reset command register 1
	TIM3->CR2 = 0;                                          // reset command register 2
	TIM3->PSC = __TIM3_PSC;                               // set prescaler
	TIM3->ARR = __TIM3_ARR;                               // set auto-reload
	TIM3->CCR1  = __TIM3_CCR1;                            //
	TIM3->CCR2  = __TIM3_CCR2;                            //
	TIM3->CCR3  = __TIM3_CCR3;                            //
	TIM3->CCR4  = __TIM3_CCR4;                            //
	TIM3->CCMR1 = __TIM3_CCMR1;                           //
	TIM3->CCMR2 = __TIM3_CCMR2;                           //
	TIM3->CCER  = __TIM3_CCER;                            // set capture/compare enable register
	TIM3->SMCR  = __TIM3_SMCR;                            // set slave mode control register
	TIM3->CR1 = __TIM3_CR1;                               // set command register 1
	TIM3->CR2 = __TIM3_CR2;                               // set command register 2
	TIM3->DIER = __TIM3_EIER;                             // enable interrupt
	NVIC->ISER[0] |= (1 << (TIM3_IRQChannel & 0x1F));  // enable interrupt
    TIM3->CR1 |= TIMX_CR1_CEN;                              // enable timer

}


/*------------------------------------------------------------------------------
  This is the GOIP config function 

// for the GPIO's the configuration is done with two settings in the 
// control registers, each two bits, for a total of four bits.
// PC8 is configured with the four lowest bits in CRH
// mode - 0/1, and CNF is 3/2
// CNF 1 is 0 for GPIO, 1 for alternate config
// CNF 0 is 0 for Push/Pull, 1 for open drain
// Mode 1,2,3 and output, and 0 is input
 *------------------------------------------------------------------------------*/
void initGPIO()
{	

    RCC->APB2ENR  |= 0x023D;

	GPIOC->CRH &= 0xFFFFFF00;																															  
	GPIOC->CRH ^= 0x0022;
	GPIOC->CRH = GPIOC->CRH | 0X0022;

	//PORT A0-15, FOR DISPLAY COL 1-16
	GPIOA->CRH =  0X22222222;
	GPIOA->CRL =  0X22222222;	
	//PORTB B2-B9, DISPLAY ROW	, B0 =nothing	   ,B1 = reserved
	GPIOB->CRL =  0x22222204;
	GPIOB->CRH &= 0xFFFFFF00;
	GPIOB->CRH ^= 0x00000022;
 	//PORTC 0-3 AS INPUT SW, PC6,8 as buz, PC7 is sunpwm
	GPIOC->CRL &= 0x00F00000; 
	GPIOC->CRL ^= 0x33038888;
   	GPIOC->CRH &= 0xFFFFFFF0;
	GPIOC->CRH |= 0x00000003;


	// enable the pull up on PC0-3
	// and the output for Sensor Power on PC4
	GPIOC->ODR = 0x0000001F;


	//D2 =zero det
  	GPIOD->CRL &= 0xFFFFF0FF; 
	GPIOD->CRL ^= 0x00000400;
	GPIOD->ODR &=0xFFF0;
	GPIOD->ODR &=0x0000;




}

