#include <stdlib.h>
#include "stm32f10x_lib.h"
#include "STM32_Reg.h"
//#include "stm32f10x.h"
#include <rtl.h>
#include <rt_misc.h>
#include "AdcDriver.h"
#include "LED_Module.h"
#include "STM32_Init.h"
#include "RTC.h"
#define EVT_FLAG1 0x0001
#define EVT_FLAG2_BUZ 0X0002
OS_TID  time_task;
OS_TID  buzz_task;
OS_MUT mut_time;
OS_MUT portc_input;

struct Time rtd;
struct Time alarm;
struct displaydata leddata1;
struct displaydata leddata2;

extern unsigned short os_time;


volatile char dimcount = 1;
volatile char lightcount = 39;
volatile char  Suncount;
volatile  char riserate = 20;
volatile char buz_flag = 0;
volatile char demo_flag = 0;
int menustate = 0;
char alarm_reset = 0;

void Ledmodule (void) ;
void VariableInit(void);
void OSInit(void);
int Push_Det(void);
void Delaynus(char nus);
void Sun(void);
void LEDDim(void);
void Alarm_Fuc(void);
void Demo(void);
__task void time (void);
__task void main_task (void);
__task void buzz (void) ;


 /*------------------------------------------------------------------------------
  RTC Interrupt Handler
 *------------------------------------------------------------------------------*/
void RTC_IRQHandler(void)
{
  if (RTC->CRL & (1<<0) ) {                       // check second flag
    RTC->CRL &= ~(1<<0);                          // clear second flag
	rtd.sec++;
//	isr_evt_set(EVT_FLAG1,time_task);
    }

  if (RTC->CRL & (1<<1) ) {                       // check alarm flag
    RTC->CRL &= ~(1<<1);                          // clear alarm flag
    
    }

} // end RTC_IRQHandler



void EXTI2_IRQHandler()
{
	// clear the interrupt
	EXTI->PR &= 0x000000004;
	menustate = GPIOC->IDR & 0x000f;
	// set the test number
	Suncount = 0;

}
void TIM3_IRQHandler (void)
{  	// check interrupt source  need to update the I/O inside the interrupt since signal the task too often cause the program to crash.
	   if ((TIM3->SR & 0x0001) != 0)   
  { 
  	   Ledmodule();
       TIM3->SR = 0x00000000;;                          // clear UIF flag
 }

}

/*------------------------------------------------------------------------------
  Timer2 Update Interrupt Handler
 *------------------------------------------------------------------------------*/
void TIM2_IRQHandler (void) {

  if ((TIM2->SR & 0x0001) != 0) 
  	{              

  Suncount ++;
  if((buz_flag) || (Suncount >riserate))Sun();

  TIM2->SR = 0x00000000; 
 	}
} // end TIM2_UP_IRQHandler

/*------------------------------------------------------------------------------
  Main 
  Create the main_task
 *------------------------------------------------------------------------------*/
int main()
{


	os_sys_init_prio (main_task, 1 );
 	

	return 1;
}
/*------------------------------------------------------------------------------
	Init the RTX event flag , mux , etc 
*------------------------------------------------------------------------------*/

void OSinit()
{
os_mut_init(mut_time);
os_mut_init(portc_input);
}


/*------------------------------------------------------------------------------
  main_task 
  Create the main_task
 *------------------------------------------------------------------------------*/
__task void main_task (void) 
{


  // create task 2, to make sure task switching is working
  time_task = os_tsk_create(time, 1);
  buzz_task = os_tsk_create(buzz, 1);

  OSinit();	
  GetRtc();
 // GerAlarm();
 	 while (1) 
  	{
   os_evt_set(EVT_FLAG1,time_task);

   if( buz_flag	)
   {
   os_evt_set(EVT_FLAG2_BUZ,buzz_task); 
   }

   Push_Det();	  
   LEDDim();
   if(!demo_flag)
   {
   Alarm_Fuc();
   }
   else
   {
   Demo();
   }
	}	

}
/*------------------------------------------------------------------------------
  Time_task 
  time task increase the clock count when RTC interrupt triggered 
 *------------------------------------------------------------------------------*/
__task void time (void) 
{



 rtd.alarmhr = 18;
 rtd.alarmmin = 37;
 rtd.sunrise = 5;
  while (1) 
  {
  	os_evt_wait_or(EVT_FLAG1,0xffff);
  	os_mut_wait(mut_time,0xffff);

		if(rtd.sec == 60)
			{			 
			 rtd.min++;
			 rtd.sec = 0;
			 alarm_reset = 0;
	
			}
			if(rtd.min==60)
			{
			alarm_reset = 0;
			rtd.hr++;
			rtd.min = 0;
			}
			if(rtd.hr==24)
			{
			rtd.hr = 0;
			}
	Display_main();			
	os_mut_release(mut_time);

//	os_dly_wait (50);
  }			
}

/******************************************************************************* /
* Function Name  : Buzz
* Description    : buzz task, generate the buz sound
* Input          : nus
* Output         : None
* Return         : None
*******************************************************************************/
__task void buzz (void) 
{

 while (1)
 {


    int delayTime = 150; // 100 ;
	int i, j, k;
   	os_evt_wait_or(EVT_FLAG2_BUZ,0xffff);


	GPIOC->ODR |=  0x00000040;

	for ( k = 1; k < 100; ++k)
	{		
		for ( j = 1; j < 1000; ++j)		
		{
			for ( i = 1; i < delayTime; ++i)
			{		
				int j = 1;
				j = j+1;
				
	
			}
			if (buz_flag )
			{
			GPIOC->ODR ^= 1 << 6;
			GPIOC->ODR ^= 1 << 8;
						}
	    }
		--delayTime;
 
 }
 GPIOC->ODR &= 0x0000001F;
}
}


/*------------------------------------------------------------------------------
	Init the local and global variables 
*------------------------------------------------------------------------------*/
void VariableInit()
{			

rtd.sunrise = 5;
buz_flag = 0;
demo_flag = 0;
}



/*------------------------------------------------------------------------------
	This is the system Init that is called at the begin of the start up
*------------------------------------------------------------------------------*/

void SystemInit()
{
 // boost to 25mhz 
	RCC->CFGR  =   0x04100000;
	RCC->CR = 	   0x01034483;
	RCC->CFGR =   0x04100002;




	initGPIO();
	Timer2();
	 Timer3();
	RTC_Init();
	EXITinit();
	VariableInit();

	initADC1Sensor();
    // this change the priority of the ISR
	NVIC->IPR[3] ^= 0X00400000;
	NVIC->IPR[3] |= 0X00020000;

	// reset the dedug port
	AFIO->MAPR =  0x00000000;


}
/*------------------------------------------------------------------------------
This function is called every timer2 interrupt to refresh the display 
*------------------------------------------------------------------------------*/

 void Ledmodule () 
{

if(!leddata1.writeflag)
{
 leddata1.readflag = 1;

  GPIOB->ODR = 0x0004;GPIOA->ODR =  leddata1.data[0];Delaynus(lightcount );	
  GPIOB->ODR = 0x0000; Delaynus(dimcount );
  GPIOB->ODR = 0x0008;GPIOA->ODR =  leddata1.data[1]; Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	Delaynus(dimcount );
  GPIOB->ODR = 0x0010;GPIOA->ODR =  leddata1.data[2]; Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	Delaynus(dimcount );
  GPIOB->ODR = 0x0020;GPIOA->ODR =  leddata1.data[3];Delaynus(lightcount);	
  GPIOB->ODR = 0x0000;	Delaynus(dimcount );
  GPIOB->ODR = 0x0040;GPIOA->ODR =  leddata1.data[4]; Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	Delaynus(dimcount );
  GPIOB->ODR = 0x0080;GPIOA->ODR =  leddata1.data[5]; Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	Delaynus(dimcount );
  GPIOB->ODR = 0x0100;GPIOA->ODR =  leddata1.data[6];Delaynus(lightcount);	
  GPIOB->ODR = 0x0000;	Delaynus(dimcount );
  GPIOB->ODR = 0x0200;GPIOA->ODR =  leddata1.data[7]; Delaynus(lightcount);	
  GPIOB->ODR = 0x0000;	 Delaynus(dimcount );
  leddata1.readflag = 0;

}	
else if(!leddata2.writeflag)
{


 leddata2.readflag = 1;

  GPIOB->ODR = 0x0004;GPIOA->ODR =  leddata2.data[0];	Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	Delaynus(dimcount);
  GPIOB->ODR = 0x0008;GPIOA->ODR =  leddata2.data[1];	   Delaynus(lightcount);
  GPIOB->ODR = 0x0000;Delaynus(dimcount);	
  GPIOB->ODR = 0x0010;GPIOA->ODR =  leddata2.data[2];	 Delaynus(lightcount);	
  GPIOB->ODR = 0x0000;	Delaynus(dimcount);
  GPIOB->ODR = 0x0020;GPIOA->ODR =  leddata2.data[3];	 Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	Delaynus(dimcount);
  GPIOB->ODR = 0x0040;GPIOA->ODR =  leddata2.data[4];	Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	 Delaynus(dimcount);
  GPIOB->ODR = 0x0080;GPIOA->ODR =  leddata2.data[5];	Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	  Delaynus(dimcount);
  GPIOB->ODR = 0x0100;GPIOA->ODR =  leddata2.data[6];	 Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	  Delaynus(dimcount);
  GPIOB->ODR = 0x0200;GPIOA->ODR =  leddata2.data[7];	Delaynus(lightcount);
  GPIOB->ODR = 0x0000;	Delaynus(dimcount);
  
  leddata2.readflag = 0;

}
}

/*------------------------------------------------------------------------------
This function detects the user input. 
*------------------------------------------------------------------------------*/
int Push_Det()
{
static int oldmenustate = 0;
int local_menustate = 0;
static unsigned int seccount;

   local_menustate =menustate ; 

if((local_menustate == 0)&&(oldmenustate !=0) &&( abs(seccount -os_time)  >50  )	 )
   {
   Menu_log(oldmenustate);
   seccount = os_time;
	if(buz_flag ) buz_flag = 0;
	if(demo_flag) buz_flag = 0;
	riserate = 20;
	oldmenustate = local_menustate;
	return 1;
   }
else
	{
   oldmenustate = local_menustate;
   return 0;
	 }


  }


/******************************************************************************* /
* Function Name  : Delaynus
* Description    : Inserts a delay time abort nus.
* Input          : nus
* Output         : None
* Return         : None
*******************************************************************************/
void Delaynus(char nus) 
{
        int nCount ;
        while(nus--)
        {
                for(nCount = 6 ; nCount != 0; nCount--);
        }

}
/******************************************************************************* /
* Function Name  : Sun pwm pulse
* Description    : generate the pulse for every semi cycle 
* Input          : nus
* Output         : None
* Return         : None
*******************************************************************************/	
void Sun()
{	
	GPIOC->ODR ^= 1 << 7;
	Delaynus(10);
	GPIOC->ODR ^= 1 << 7;
}

/******************************************************************************* /
* Function Name  : LEDDim
* Description    : Adjust the LED dim rate based on ADC1 reading
* Input          : nus
* Output         : None
* Return         : None
*******************************************************************************/
void  LEDDim()
   {
    int lightread;
    static int Leddimflag = 0; 
	 lightread = getTemperature() ;
	 //Dim the Led
	 if((lightread < 0x7A0)&&(Leddimflag ==0))
	 {	
		Leddimflag = 1;
		dimcount = 20;
		lightcount = 20;

	 }
	 // Undim the Led
	 else if((lightread >0xA50)&&(Leddimflag ==1) )
	 {
	 	Leddimflag = 0;
		dimcount = 1;
		lightcount = 39;
	 }
    
   }
/******************************************************************************* /
* Function Name  : Alarm_Fuc
* Description    : This is the main alarm function, calcuate the sunrise rate and trigger the buz
* Input          : nus
* Output         : None
* Return         : None
*******************************************************************************/

 void Alarm_Fuc()
 {
 unsigned int rtccount;
 unsigned int alarmcount;
 unsigned int finalcount;
 unsigned int local_sunrise ;

 rtccount = rtd.hr * 60 + rtd.min;
 alarmcount = rtd.alarmhr * 60 + rtd.alarmmin;
 finalcount = 0xff;


 local_sunrise = rtd.sunrise ;


 if ( (rtd.hr == 23) &&  (rtd.alarmhr == 0)	)
  {
   finalcount =   (60 -rtd.min) + rtd.alarmmin;

   }

 else if (rtccount < alarmcount)
	{
     
		finalcount = alarmcount - rtccount;
	
	}

   if(finalcount < 61)
   {
   switch (local_sunrise)
   {
    case 5:
	if(finalcount <6) riserate = finalcount * 3 ;


   break;

   case 15:

   if(finalcount <16) riserate = finalcount  ;

   break;

   case 30:

   if(finalcount <31) riserate = (finalcount / 2) ;

   break ;

   case 45:
   if(finalcount <46) riserate = (finalcount / 3) ;
   break ;

   case 60:
    if(finalcount <60) riserate = (finalcount / 4) ;
   break ;

   default:
   rtd.sunrise = 5;
   break;
   
   }
   
     
   }




 if((rtd.alarmmin ==rtd.min) &&(rtd.alarmhr == rtd.hr) &&(alarm_reset ==0)	)
 {
  buz_flag = 1;
  alarm_reset = 1;
  riserate = 1;
 }
 

 }

 /******************************************************************************* /
* Function Name  : Demo
* Description    : A demo function 
* Input          : nus
* Output         : None
* Return         : None
*******************************************************************************/

 void  Demo()
 {

 static int seccount = 0;
 static int local_sec =0 ;
 if(rtd.sec != local_sec)
{
seccount ++;
local_sec = rtd.sec	 ;
}

if(seccount ==2)
{
riserate = 14;
}
else if(seccount == 4)
{
riserate = 12;
}
else if(seccount == 6)
{
riserate = 11;
}
else if(seccount == 8)
{
riserate = 10;
}
else if(seccount == 10)
{
riserate = 9;
}
else if(seccount == 12)
{
riserate = 8;
}
else if(seccount == 14)
{
riserate = 7;
}
else if(seccount == 17)
{
riserate = 6;
}
else if(seccount == 18)
{
riserate = 5;
}
else if(seccount == 19)
{
riserate = 4;
}
else if(seccount == 20)
{
riserate = 3;
}

else if(seccount == 21)
{
riserate = 1;
buz_flag = 1 ;
}
else if(seccount > 25)
{
riserate = 20;
buz_flag = 0;
seccount = 0;
}



 
 
 
 }
